#!/bin/bash
#
# Usage: cview.sh [path]
#
# Description: Download and run several cview-based applications
#   You may optionally provide a path to a local copy of cview

set -e

mkdir -p data
cd data

workdir=$(pwd)

# Amfora - Gemini browser
cd $workdir
if [ ! -d amfora ]
then
	git clone https://github.com/makeworld-the-better-one/amfora
	cd amfora
else
	cd amfora
	git pull
fi
if [ ! -z "$1" ]; then
	go mod edit -replace code.rocketnine.space/tslocum/cview="$1"
fi
go mod tidy
make clean
make
./amfora

# gmenu - Desktop application launcher
cd $workdir
if [ ! -d gmenu ]
then
	git clone https://code.rocketnine.space/tslocum/gmenu
	cd gmenu
else
	cd gmenu
	git pull
fi
if [ ! -z "$1" ]; then
	go mod edit -replace code.rocketnine.space/tslocum/cview="$1"
fi
cd cmd/gmenu
go mod tidy
go build
./gmenu

# netris - Tetris clone
cd $workdir
if [ ! -d netris ]
then
	git clone https://code.rocketnine.space/tslocum/netris
	cd netris
else
	cd netris
	git pull
fi
if [ ! -z "$1" ]; then
	go mod edit -replace code.rocketnine.space/tslocum/cview="$1"
fi
cd cmd/netris
go mod tidy
go build
./netris
